#!/usr/bin/perl -w 
#!C:\Programmierung\Perl\bin\perl -w 
# "Analoges - "mW-Meter" "
# (c) DH1AAD / Ingo Gerlach   
#
#
# 0.1	29.03.2003	Basiert auf analog...pl 
#			Umstellung Win & Linux , Serieller-Port 
#			fr ADC1001 / ADC0803  mit AD8361 , Analoges mW-Meter 
#
#---------------------------------------------------------------------------------
#-----------------------       C V S - I n f o    --------------------------------
#---------------------------------------------------------------------------------
# Info : $Id: adc_analog.pl,v 1.7 2003/04/21 18:29:56 ingo Exp $
# Log  : $Log: adc_analog.pl,v $
# Log  : Revision 1.7  2003/04/21 18:29:56  ingo
# Log  : Stand_21_04_03
# Log  :
# Log  : Revision 1.6  2003/04/14 21:12:57  ingo
# Log  : Stand_14_04_03
# Log  :
# Log  : Revision 1.5  2003/04/11 18:16:20  ingo
# Log  : CFG Multi , definition fehlte
# Log  :
# Log  : Revision 1.4  2003/04/08 19:06:05  ingo
# Log  : Docu hinzu
# Log  :
# Log  : Revision 1.3  2003/04/07 17:32:10  ingo
# Log  : ige : 07.04.03 Erweiterte Anzeige hinzu.
# Log  :
# Log  : Revision 1.2  2003/04/05 06:43:57  ingo
# Log  : Backup 050403
# Log  :
#---------------------------------------------------------------------------------
#-----------------------       C V S - E n d e     -------------------------------
#---------------------------------------------------------------------------------

#---------------------------------------------------------------------------------
#-----------------------        Module          ----------------------------------
#---------------------------------------------------------------------------------

use strict; 
use vars qw($opt_c $opt_d $opt_w $opt_h $OS_win);
use IO::Handle;
use File::Basename;

autoflush STDOUT;
autoflush STDERR;

BEGIN {

 unshift(@INC,"./lib");

 $OS_win = ($^O eq "MSWin32") ? 1 : 0;
 if ($OS_win) {
  eval "use Win32::SerialPort 0.11";
  die "$@\n" if ($@);
 }
  else {
   eval "use Device::SerialPort";
   die "$@\n" if ($@);
  }
} # End BEGIN

use Tk; 
use Carp; 
use adc_utils;					# diveres pop_up...
use Getopt::Std;

#---------------------------------------------------------------------------------
#-----------------------       # Functions      ----------------------------------
#---------------------------------------------------------------------------------

sub change_();
sub call_createDisplay();
sub clear_screen(); 
sub createDisplay(); 
sub create_pointer($ $); 
sub createTags();
sub deg2bog($);
sub createLabel($ $ $ $);
sub get_AD();
sub create_pointer($ $);
sub create_pointer1($);
sub dispOpt();
sub dispValue($);
sub analog_setup();
sub init_port();
sub my_exit();
sub init_port();
sub deg2bog($);
sub invlog10;
sub log10;
sub setup();
sub my_ok();
sub my_cancel();
sub fill_lb($);
sub cfg_select();

####

#---------------------------------------------------------------------------------
#---------------------------      Constanten     ---------------------------------
#---------------------------------------------------------------------------------

my $VERSION    		= "0.1";
my $COPYRIGHT  		= "(c) Ingo Gerlach / DH1AAD";
my $VERSION_DATE	= "03/2003"; 
my $PROG_TITLE		= "mW-Meter";
my $def_config		= "adc.cfg";		# aktuelle CFG, kann mit -c name.cfg gendert werden	

my $error_log		= "log/adc_analog.log";	# Error Logging
my $temp_file		= "log/adc_temp";	# Temp File
my $error_log_size	= 1000000;		# Groesse Logfile

my $PI			= 3.141592654;		# PI
my $debug		= 0;			# Debug Mode 

#---------------------------------------------------------------------------------
#---------------------------  # Error Loging starten  ----------------------------
#---------------------------------------------------------------------------------

if (! $debug) {
 adc_utils::check_log_size($error_log,$error_log_size);
}
adc_utils::logmsg("Start $0");

#---------------------------------------------------------------------------------
#---------------------------  Variablen aus Config    ----------------------------
#---------------------------------------------------------------------------------

my %cfg;					# Config-Hash

# Default Konfiguration ist Anzeige ADC , 10 Bit AD ADC1001
# COM2 wenn Windows bzw. /dev/ttyS0 bei Linux 

$cfg{"TITLE"}		= $PROG_TITLE; 		# Title

# Com-Port 
if ($OS_win) {
 $cfg{"portname"} 	= "COM2";		# Linux /dev/ttySx , WIN COMx
} else {
 $cfg{"portname"} 	= "/dev/ttyS0";		# Linux /dev/ttySx , WIN COMx
}
$cfg{"baudrate"} 	= 9600;			# Ser-Port Parameter 
$cfg{"parity"}   	= 'none';		# 
$cfg{"databits"} 	= 8;
$cfg{"stopbits"} 	= 1;
$cfg{"handshake"} 	= "none";

$cfg{"interval"}	= 50;			# Anzeige Interval ms
$cfg{"Debug"}		= 0;			# Debug 

# AD Wandler ADC0803 / ADC1001
$cfg{"ADC_REFUB"}	= 5.00;			# Ref Ub AD Wandler  
$cfg{"ADC_OPAMP"}	= 1.0;			# Verstrkung Op LM358
$cfg{"ADC_DIG"}		= 1023;			# ADC 1001 = 1023 , ADC0803 255
$cfg{"MULTI"}		= 1;			# Multiplikator des Berechneten Wertes

# Anzeige Function , 0 = ADC , 1= Vrms , 2 = mW , 3 = dBm
$cfg{"FUNC"}		= 0;

# Anzeige 
$cfg{"display"}		= 1;			# Anzeige digital , 0 = aus , 1 Nur aktueller Wert, 2 alle Werte
$cfg{"optdisplay"}	= 1;			# Anzeige OptionsTex unten rechts
$cfg{"opttext"}		= "DH1AAD";		# 
$cfg{"disp_tdist"}	= 0.1;		
$cfg{"disp_ldist"}	= 0.25;	
$cfg{"c_a_disp"}	= 'black';		# "Digital Anzeige"

# Farben
$cfg{"c_a_background"}	= 'LightYellow';	# Skalen Hintergrund	
$cfg{"c_a_outFrame"}	= 'black';		# Rahmen Rechteck
$cfg{"c_a_Label"}	= 'blue';		# Beschriftung
$cfg{"c_a_Scale"}	= 'black';		# Skala
$cfg{"c_a_pointer"}	= 'black';		# Zeiger
$cfg{"c_a_pointer_shd"}	= 'grey';		# Zeiger Schatten
$cfg{"c_a_tags"}	= 'black';		# Zeiger
$cfg{"c_a_info"}	= 'red';		# Optionen Anzeige

# Skalen Var's , (konfigurierbar)
$cfg{"Label"}		= "ADC";		# Label
$cfg{"angle"}		= 50;			# Auszufllender Winkel
$cfg{"scale_width"}	= 1;			# Breite der Skala
$cfg{"label_div"}	= 1;			# Teiler fr Anzeige

# Beschriftungs Var's (konfigurierbar)
$cfg{"start_val"}	= -0;			# Startwert , linke SkalenSeite
$cfg{"end_val"}		= $cfg{ADC_DIG};	# Endwert , rechte Skalenseite
$cfg{"step_val_b"}	= ($cfg{ADC_DIG} > 256 ? 256 : 25);			# Schrittweite 10 , Beschriftung
$cfg{"step_val_s"}	= 25;			# Schrittweite 1 , kleiner Strich
$cfg{"range_max"}	= 5;			# Max. Att-Bereich 

$opt_c = "";
$opt_d = "";
$opt_w = "";
getopts('c:d:wh');

if ($opt_h) { system("perldoc $0");exit(0); }

if ($opt_c ne "") {
 $def_config = $opt_c;
 if ((! $opt_w) && (! -f $def_config)) { print "Config $def_config not found and -w missed \n"; exit(1); }
 %cfg=&adc_utils::get_config($def_config,\%cfg);	# Variablen aus CFG einlesen
 adc_utils::logmsg("Config $def_config");
 $debug = $cfg{"Debug"};
}

if($opt_w) {
 adc_utils::write_config($def_config,%cfg);
 adc_utils::logmsg("Write Config $def_config");
}

#---------------------------------------------------------------------------------
#----------------------------------  Variablen     -------------------------------
#---------------------------------------------------------------------------------

my $COM_INIT    	= 0;			# True , wenn Init OK  
my $comport;

# Main Window 
my $Xco 		= 800; 			# Vorgabe , nach Mainwindow werden diese Werte angepasst.. 
my $Yco 		= 600; 
my $canvas; 					# Screen 
my $xw			= 1;
my $yw			= 1;
my $i			= 0;    

# Setup Window
my $lb;						# Listbox
my @cfg_files;
my $cfg_active 		= 0;
my $dir;
my $config;
my $smain;
my $llab;

# ADC Vars
my $adc_val		= 1;			# Aktueller eingelesener Wert
my $avg_val 	= 1.0;			# Aktueller mittlerer Wert
my $dbm_val		= 1.0;			# Berechneter Wert dbm
my $vrms_val	= 1.0;			# Berechneter Wert VRMS
my $mw_val		= 1.0;			# Berechneter Wert mW	
my $lab_mw		= "mW/dBm";
my $att			= 0;
my %att_val		=("0"=>0,"1" =>3,"2"=>5,"3"=>10,"4"=>20,"5"=>30);    
my %att_text	=("0"=>"0 dB","1" =>"-3 dB","2"=>"-5 dB","3"=>"-10 dB","4"=>"-20 dB","5"=>"-30 dB");

# Skalen Var's
# Werte ersteinmal vorbelegen damit kein DIV/0

my @points;					# Koordinaten der einzelnen Teilbgen.
my @delta;					# deltas x/y
my $tag_len;					# Lnge der Skalen Striche
my $start_angle		= 1;			# Start Winkel II. Quadrant
my $end_angle		= 1;			# Start Winkel I. Quadrant
my $radius			= 1;			# Radius
my $range			= 1;			# Bereich z.B. -10 bis 40 = 50
my $ad_angle		= 1;			#
my $cen_x			= 1;			# Cetrum X
my $cen_y			= 1;			# Cetrum Y
my $start_x			= 1;			# Start X , Skala
my $start_y			= 1;			# Start Y , Skala
my $f_dif  			= 6;			# Abstand, uerer Rand
my $s_dist			= 0.075;		# Abstand, uerer Rand zur Skala (Faktor)
my $t_dist 			= 2.5;			# Abstand, ob. Rand zur Skala (Faktor) oben
my $tag_faktor		= 0.0125;		# Hhe x $tag_len
my $font_aspect		= 1;			# xw/yw Verhltnis
my $font_height 	= 10;			# Hhe , wird berechnet.
my $font_h_div		= 10;			# Teiler (Font)
my $font_l_div		= 0.65;			# Faktor Beschriftung (Label)
my $font_t_dist		= 3;			# Abstand Beschriftung Skala
my $font			= 'Arial '.$font_height.' normal';
my $angle_step		= 1;			# Schrittweite

# Zeiger 
my $pointer_len		= 1.02;			# $radius * pointer_len
my $pointer_len_shd	= 1.018;		# $radius * pointer_len
my $pointer_shade	= 1;			# Schatten ein / aus
my $pointer_width	= 1.4;			# Zeiger Breite
my $range_start		= $cfg{"start_val"};	# Start / Endbereich sichern
my $range_end		= $cfg{"end_val"};

#---------------------------------------------------------------------------------
#----------------------------------  Start Main    -------------------------------
#---------------------------------------------------------------------------------

    $dir = dirname($def_config);
    $COM_INIT = init_port();				# Port Setup
    my $main;
    $main = tkinit(-background =>'darkblue',fg=>'blue');# new MainWindow(-background => 'darkblue'); # Menue Zeile 
    $main-> title($cfg{"TITLE"});				# Title 

    my $Y_Screen_Max=$main->screenheight();		# Max. Auflsung Y 
    my $X_Screen_Max=$main->screenwidth();		# Max. Auflsung X 
  
    adc_utils::CenterWindow($main,400,241);  	# Legt die Groesse des Fensters fest und zentriert es 
    $main-> minsize(150,80);					# Minimale erlaubte Groesse 

 	# Frame  
    my $mbot_fr	=$main->Frame(-relief=>'groove',-borderwidth=>1,-height=>0)->pack(-side=>'bottom',-fill=>'both',-expand=>'x',-ipady=>1);    
	if ($cfg{"display"}==2) {
     $mbot_fr->Label(-text=>" ",-width=>1,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>'x');
     $mbot_fr->Label(-text=>"ADC:",-width=>6,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>'x');
     $mbot_fr->Label(-relief=>"sunken",-width=>7,-textvariable=>\$avg_val)->pack(-side=>'left');    
     $mbot_fr->Label(-text=>"U:",-width=>2,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>'x');
     $mbot_fr->Label(-relief=>"sunken",-width=>7,-textvariable=>\$vrms_val)->pack(-side=>'left');    
     $mbot_fr->Label(-text=>"P:",-width=>2,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>'x');
     $mbot_fr->Label(-relief=>"sunken",-width=>7,-textvariable=>\$mw_val)->pack(-side=>'left');    
     $mbot_fr->Label(-textvariable=>\$lab_mw,-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>'x');
     $mbot_fr->Label(-relief=>'sunken',-width=>7,-textvariable=>\$dbm_val)->pack(-side=>'left');    
     $mbot_fr->Label(-text=>" ",-width=>1,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>'x');
	} 

    # Canvas erzeugen 		 
    $canvas 	= $main->Canvas(-background => $cfg{"c_a_background"},
                                 -borderwidth=>2,-closeenough=>5,-relief=>'groove');
    $canvas->pack(-anchor=>'w', -fill => 'both',-side=>'top',-expand=>'yes'); 

    # Groessenaenderung Feststellen 
    $canvas->CanvasBind("<Configure>",\&call_createDisplay);     
    
    create_pointer(1,1);
    
    # Zeiger aktualisieren 
    $canvas->repeat($cfg{"interval"},\&get_AD);
    
    # Strg-Q Ende
    $main->bind('<Control-q>', sub { my_exit();});   
    $main->bind('<Control-a>', sub { analog_setup();});   
    MainLoop; 
 
#---------------------------------------------------------------------------------
#----------------------------------  Ende  Main    -------------------------------
#---------------------------------------------------------------------------------

#---------------------------------------------------------------------------------
#----------------------------------  Subs  Analog  -------------------------------
#---------------------------------------------------------------------------------

sub call_createDisplay () {
 my $geom = $canvas->geometry(); 
 my @temp = split(/([x+])/,$geom); 
 clear_screen(); 
 $canvas->configure(-width=>(1.0*$temp[0]),-height=>1.0*$temp[2]); 
 createDisplay(); 
 create_pointer(0,0); 
}

sub createDisplay() {
my $i;
my $a;
my $b;
my $sin_a; 
my $d_a;
my $d_b;
my $tag_a;
my $tag_b;
my $temp;
my $n 		= 0;
my $label	= $cfg{"start_val"};
 
 $xw 		= $canvas->cget(-width); 	# Breite 
 $yw 		= $canvas->cget(-height); 	# Hhe
 $canvas->createRectangle($f_dif,$f_dif,$xw-$f_dif,$yw-$f_dif,-outline=>$cfg{"c_a_outFrame"},-width=>2);
 
 $canvas->configure(-background=>$cfg{"c_a_background"});

 # Fontgrssenverhltnis
 $font_aspect 	= (($yw*$xw)/($xw+$yw));

 # Bereich Berechnen
 
 if ($cfg{"start_val"} <0) {
  $range = (($cfg{"start_val"}*-1)+$cfg{"end_val"});
 } else {
  $range = ($cfg{"start_val"}+$cfg{"end_val"});
 }

 $angle_step 	= $cfg{"angle"} / $range;
 $ad_angle	= ($cfg{"ADC_DIG"} / $range);
 
 # print "angle $angle_step, angle $cfg{"angle"} range $range , ad_angle $ad_angle \n";
 # linker Startpunkt Skala
 $start_x 	= int($xw*$s_dist)+$f_dif;
 $start_y 	= int($yw/$t_dist);
 
 # Lnge a berechnen
 $a = int($xw/2) - $start_x;
 
 # Radius (c) berechnen
 $radius = $a / sin(deg2bog($cfg{"angle"}/2));
 
 # Lnge b berechnen
 $b      = cos(deg2bog($cfg{"angle"}/2)) * $radius;
  
 # Start/End Winkel
 $start_angle = 90 + ($cfg{"angle"} / 2);
 $end_angle   = $start_angle - $cfg{"angle"};
 
 # Centrum bestimmen
 $cen_x  = $start_x + $a;
 $cen_y  = $start_y + $b;
 
 # Punkte bestimmen
 undef @points; 
 undef @delta;
 
 $tag_len = $yw * $tag_faktor;
  
 for($i=$start_angle;$i>$end_angle-$angle_step;($i-=$angle_step)) {
  $sin_a = $i - 90;
  $d_a   = sin(deg2bog($sin_a)) * $radius;
  push(@points,(($xw/2) - $d_a));
  push(@delta,$d_a);
  $d_b    = cos(deg2bog($sin_a)) * $radius;
  push(@points,($cen_y - $d_b));
  push(@delta,$d_b);
 }
 
 # Bogen Zeichnen
 $canvas->createLine($start_x,$start_y,@points,-width=>$cfg{"scale_width"},-smooth=>1,-joinstyle=>"miter",-splinesteps=>200,-fill=>$cfg{"c_a_Scale"});
  
 # Grosses Label 
 createLabel(($xw/2),($start_y),$cfg{"Label"},$font_aspect);
 
 # Tags
 createTags();
 
}

sub createTags() {
my $tag_a;
my $tag_b;
my $sin_a;
my $i;
my $n=0;
my $counter=0;
my $temp;
my $label=$cfg{"start_val"} ;

 $tag_len = $yw * $tag_faktor;
 
 # Striche berechnen 
 for($i=$start_angle;$i>$end_angle-$angle_step;($i-=$angle_step)) {
  $sin_a = $i - 90; 
  $tag_a = int(($xw/2) - (sin(deg2bog($sin_a)) * ($radius+$tag_len)));
  $tag_b = int($cen_y  - (cos(deg2bog($sin_a)) * ($radius+$tag_len)));
  $temp = $counter % $cfg{"step_val_b"};
  if($temp == 0) {
   $canvas->createLine((($xw/2) - $delta[$n]),($cen_y - $delta[$n+1]),$tag_a,$tag_b,-fill=>$cfg{"c_a_tags"},-width=>3);
   createLabel($tag_a,$tag_b-($tag_len*$font_t_dist),$label,$font_aspect*$font_l_div);
   $label+=($cfg{"step_val_b"} / $cfg{"label_div"});
  } 
  $temp = $counter % $cfg{"step_val_s"};
  if($temp == 0) {
   $canvas->createLine((($xw/2) - $delta[$n]),($cen_y - $delta[$n+1]),$tag_a,$tag_b,-fill=>$cfg{"c_a_tags"},-width=>1);
  } 
  $n+=2;
  $counter++;
 } 
}

sub clear_screen() { 
 $canvas->delete('all'); 
} 

sub createLabel($ $ $ $) {
 my $cen_x 		= $_[0];
 my $cen_y 		= $_[1];
 my $label		= $_[2];
 my $height		= $_[3];
 my $font_height	= int($height / $font_h_div);
 # $font	= '-adobe-helvetica-medium-r-normal--'.$font_height.'-180-75-75-p-98-iso8859-1';# Der Verwendete FontString
 $font  = 'Arial '.$font_height.' normal';
 $canvas->createText($cen_x,$cen_y,-text=>$label,-fill=>$cfg{"c_a_Label"},-justify=>'center',-font=>$font);
 # print "Height $height , $font_height $font\n";
}

sub get_AD() {
my $value = 0;
my $avg;
my $result;
my $temp; 
my $f_val = 0;

 if ($COM_INIT>0) {
  $result = $comport->input;
  if ($result =~ /^>\s*(\d*);(\d+)</) {
   $value  = $1;
   $att	   = $2;
  }
  if ($value > 0) { 
   # $a = int(($value + $mval) / 2); 		# Arith	
   # $a = int((2*$value*$mval)/($value+$mval)); # Harm. 
   $adc_val 	= $value ;  # AD von ADC	
   $avg 	= int(sqrt($adc_val*$avg_val)); 	# geom. Mittel
   $vrms_val 	= (($avg * ($cfg{"ADC_REFUB"}/$cfg{"ADC_DIG"})) / 7.50)* invlog10($att_val{$att}/20.0);	# Berechnung VRMS 
   $mw_val 	= (($vrms_val * $vrms_val) / 50.0);
   $dbm_val 	= 10.0*(log10($mw_val / 0.001));
   if 	 ($cfg{"FUNC"} == 0) { $f_val = $avg; }
   elsif ($cfg{"FUNC"} == 1) { $f_val = $vrms_val; }
   elsif ($cfg{"FUNC"} == 2) { $f_val = $mw_val; }
   elsif ($cfg{"FUNC"} == 3) { $f_val = $dbm_val; }
   else { $f_val = $avg; }
   
   if(($mw_val*1000) > 100) {
    $lab_mw = " W/dBm ";
   } else { $lab_mw = " mW/dBm "; $mw_val*=1000;}

   $vrms_val = sprintf("%3.3f",$vrms_val);
   $mw_val   = sprintf("%4.3f",$mw_val);
   $dbm_val  = sprintf("%3.2f",$dbm_val);
   
   create_pointer1($f_val * $cfg{"MULTI"}); 
   # $temp = sprintf("VRMS:%4.3f / mW:%4.3f dBm:%4.3f",$vrms_val,$mw_val*1000.0,$dbm_val);
   print "VALUE:$value / f_val $f_val /  ADC:$adc_val / AVG:$avg_val / ATT:$att_val{$att}  dBm:$dbm_val Vrms:$vrms_val  \n" if $debug;
   $avg_val = $avg;
  }
 }
}


sub create_pointer1($) {
my $val = $_[0];
# my $swr = $_[1];
my $aktval=1;
my $aktangle=1;
my $sin_a=1;
my $tag_a=1;
my $tag_b=1;

 $canvas->delete('ptext'); 
 #if($cfg{"MG_KL"} != 0.0) {
 #  $aktval = (($cfg{"MG_MIN"} - $cfg{"start_val"}) + ($val / $cfg{"MG_KL"})) - $cfg{"offset"};
 # } else {  $aktval = ($val / $ad_angle); }
 # $aktval = ($val / $ad_angle); 
 
 $aktval = $val;
 $aktangle 	= $start_angle - ($angle_step * $aktval);
 
 # print "Value $val startangle $start_angle aktval $aktval, akt_angle $aktangle ad_angle $ad_angle \n" if $debug;
 $sin_a = $aktangle - 90; 
 $tag_a = int(($xw/2) - (sin(deg2bog($sin_a)) * ($radius*$pointer_len)));
 $tag_b = int($cen_y  - (cos(deg2bog($sin_a)) * ($radius*$pointer_len)));
 $canvas->coords("pointer1",$cen_x,$cen_y,$tag_a,$tag_b);
 if ($pointer_shade) {
  $tag_b = int($cen_y  - (cos(deg2bog($sin_a)) * ($radius*$pointer_len_shd)));
  $canvas->coords("pshade",$cen_x+(2*$pointer_width),$cen_y,$tag_a+(2*$pointer_width),$tag_b);
 } 
 
 dispValue($aktval);
 
 if ($cfg{"optdisplay"}) {
  dispOpt();
 }

}

sub create_pointer($ $) {
my $val = $_[0];
my $swr = $_[1];
my $aktval=1;
my $aktangle=1;
my $sin_a=1;
my $tag_a=1;
my $tag_b=1;
 
 $canvas->delete('pointer');
 $canvas->delete('pshade');
 $canvas->delete('ptext');
 # if($cfg{"MG_KL"} != 0.0) {
 #  $aktval = (($cfg{"MG_MIN"} - $cfg{"start_val"}) + ($val / $cfg{"MG_KL"})) - $cfg{"offset"};
 # } else {  $aktval = ($val / $ad_angle); }
 
 $aktval = $val;
 $aktangle 	= $start_angle - ($angle_step * $aktval);

 $sin_a = $aktangle - 90; 
 $tag_a = int(($xw/2) - (sin(deg2bog($sin_a)) * ($radius*$pointer_len)));
 $tag_b = int($cen_y  - (cos(deg2bog($sin_a)) * ($radius*$pointer_len)));
 $canvas->createLine($cen_x,$cen_y,$tag_a,$tag_b,-fill=>$cfg{"c_a_pointer"},-width=>$pointer_width,-tags=>'pointer1');  
 if ($pointer_shade) {
  $tag_b = int($cen_y  - (cos(deg2bog($sin_a)) * ($radius*$pointer_len_shd)));
  $canvas->createLine($cen_x+(2*$pointer_width),$cen_y,$tag_a+(2*$pointer_width),$tag_b,-fill=>$cfg{"c_a_pointer_shd"},-width=>$pointer_width,-tags=>'pshade');  
 } 
 # if ($cfg{"display"} > 0) {
  dispValue($aktval);
 # }

 if ($cfg{"optdisplay"}) {
  dispOpt();
 }
}

# Anzeige Opt-Text 
sub dispOpt() {
 $canvas->createText(($xw/2)+($xw*$cfg{"disp_ldist"}),$yw-($yw*$cfg{"disp_tdist"}),-text=>$cfg{"opttext"},-fill=>$cfg{"c_a_info"},-justify=>'center',-font=>$font,-tags=>'pointer');
}

sub dispValue($) {
 my $xval =  $_[0];
 my $temp;
 if (($cfg{"display"} == 0) or ($cfg{"display"} == 2)){
  $temp  = sprintf("%s",$att_text{$att});
 } elsif ($cfg{"display"} == 1) {
   $temp  = sprintf("%4.2f $cfg{'Label'}\n%s",(($cfg{"start_val"}+$xval)/$cfg{"label_div"}),$att_text{$att});
 } 
 $canvas->createText(($xw/2)-($xw*$cfg{"disp_ldist"}),$yw-($yw*$cfg{"disp_tdist"}),-text=>$temp,-fill=>$cfg{"c_a_disp"},-justify=>'center',-font=>$font,-tags=>'ptext');
}

sub analog_setup() {
 if (! -f $def_config) {
  adc_utils::write_config($def_config,%cfg);
 } 
 setup();
}

sub my_exit() {
 $main->destroy();
 $comport->close || adc_utils::logmsg("Close failed");
 adc_utils::logmsg("Stop $0"); 
 exit(0);
}

sub init_port() {
my $ret = 0;
 # Define the port
 if ($OS_win) {
  $comport = new Win32::SerialPort ($cfg{portname}) || die "Can't open new port [$cfg{portname}], error [$^E]";
 } else {  $comport = new Device::SerialPort ($cfg{portname}) || die "Can't open new port [$cfg{portname}], error [$^E]"; }

 # Set the port's comm parameters
 $comport->user_msg("ON");
 $comport->baudrate($cfg{baudrate});
 $comport->parity($cfg{parity});
 $comport->databits($cfg{databits});
 $comport->stopbits($cfg{stopbits});
 $comport->handshake($cfg{handshake});
 $comport->write_settings ;
 $ret = 1;

 return($ret); 
}

#---------------------------------------------------------------------------------
#------------------------------    div. Math     ---------------------------------
#---------------------------------------------------------------------------------

sub deg2bog($) {
 return (($PI * $_[0]) / 180);
}

sub invlog10 {
 my $n = shift;
 return exp($n * log(10));
}

sub log10 {
 my $n = shift;
 return log($n)/log(10);
}

#---------------------------------------------------------------------------------
#------------------------------        Setup     ---------------------------------
#---------------------------------------------------------------------------------

 sub setup() {
    $config  = $def_config;
          
    adc_utils::logmsg("Analog_Setup Config: $dir , $config");
    %cfg=&adc_utils::get_config($config,\%cfg); # Variablen aus CFG einlesen 
   
    $smain = tkinit();# new MainWindow(-background => 'darkblue'); # Menue Zeile 
    $smain-> title("Analog Setup");		# Title 
    adc_utils::CenterWindow($smain,425,500);  	# Legt die Groesse des Fensters fest und zentriert es 
    $smain->configure(-borderwidth=>1); 

    # Top Dist.
    my $mTopF = $smain->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-anchor=>'nw',-fill=>'x',-ipady=>5); 
    # Distance left side 
    my $mLeftF = $smain->Frame(-relief=>'groove',-borderwidth=>0,-width=>10)->pack(-side=>'left',-anchor=>'nw',-fill=>'y');
    # Distance right side 
    my $mRightF = $smain->Frame(-relief=>'groove',-borderwidth=>0,-width=>10)->pack(-side=>'right',-anchor=>'nw',-fill=>'y');

    my $mBotFt= $smain->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'bottom',-anchor=>'s',-fill=>'x',-ipady=>5);
    my $mBotF = $mBotFt->Frame(-relief=>'groove',-borderwidth=>1)->pack(-side=>'bottom',-anchor=>'sw',-fill=>'x');
    $mBotF->Button(-text=> 'Cancel',-command=> sub { my_cancel();})->pack(-side=>'left',-anchor=>'s',-expand=>1,-fill=>'x'); 
    $mBotF->Button(-text=> 'Ok',-command=> sub {my_ok();})->pack(-side=>'right',-anchor=>'s',-expand=>1,-fill=>'x');  

    my $lab_height = 300;
    
    my $top_frame	=$smain->Frame(-relief=>'groove',-borderwidth=>2)->pack(-side=>'top',-fill=>'both',-expand=>0,-ipady=>1);
    my $top_frameb	=$top_frame->Frame(-label=>"Analog-Setup",-relief=>'groove',-borderwidth=>2,-height=>$lab_height)->pack(-side=>'top',-fill=>'both',-expand=>0,-ipady=>5);    

    my $top_fr00	=$top_frameb->Frame(-relief=>'groove',-borderwidth=>2)->pack(-side=>'top',-fill=>'x',-expand=>1,-ipady=>3);
    $top_fr00->Label(-text=>"Config:",-width=>9,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    # $top_fr00->Label(-textvariable=>\$config,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    # Listbox
    $lb = $top_fr00->Scrolled("Listbox",-scrollbars=>'e',-setgrid=>0,-width=>40,-height=>2,-selectmode=>'single',-borderwidth=>1)->pack(-side=>'left',-expand=>1);
    fill_lb($config); 			# Liste fuellen
    $lb->see($cfg_active);		# Activieren und 	
    $lb->selectionSet($cfg_active);	# Anzeigen
     
    my $top_fr0		=$top_frameb->Frame(-relief=>'groove',-borderwidth=>2)->pack(-side=>'top',-fill=>'x',-expand=>1,-ipady=>3);
    #    $top_fr0->Label(-text=>"Server:",-width=>9,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #    $top_fr0->Radiobutton(-text => 'On' ,-value=>1,-width=>2,-variable=>\$cfg{"SERVER"})->pack(-side=>'left',-fill=>"x",-expand=>0);
    #    $top_fr0->Radiobutton(-text => 'Off',-value=>0,-width=>5,-variable=>\$cfg{"SERVER"})->pack(-side=>'left',-fill=>"x",-expand=>0);
    $top_fr0->Label(-text=>"Debug:",-width=>6,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $top_fr0->Radiobutton(-text => 'On' ,-value=>1,-width=>2,-variable=>\$cfg{"Debug"})->pack(-side=>'left',-fill=>"x",-expand=>0);
    $top_fr0->Radiobutton(-text => 'Off',-value=>0,-width=>5,-variable=>\$cfg{"Debug"})->pack(-side=>'left',-fill=>"x",-expand=>0);

    #my $top_fr1		=$top_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>1,-ipady=>0);
    #$top_fr1->Label(-text=>"Socket:",-width=>15,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #$top_fr1->Entry(-background=>'white',-width=>42,-textvariable=>\$cfg{"SOCKET_NAME"})->pack(-side=>'left');    

    #my $top_fr2		=$top_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>1,-ipady=>0);
    #$top_fr2->Label(-text=>"Server Start:",-width=>15,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #$top_fr2->Entry(-background=>'white',-width=>42,-textvariable=>\$cfg{"SERVER_BIN"})->pack(-side=>'left');    

    #my $top_fr3		=$top_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>1,-ipady=>0);
    #$top_fr3->Label(-text=>"I2C-Portdelay:",-width=>15,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #$top_fr3->Entry(-background=>'white',-width=>12,-textvariable=>\$cfg{"I2C_PORTDELAY"})->pack(-side=>'left');    

    my $top_fr4		=$top_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>1,-ipady=>3);
    $top_fr4->Label(-text=>"Device:",-width=>6,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    # $top_fr4->Radiobutton(-text => 'Auto' ,-value=>0,-width=>6,-variable=>\$cfg{"I2C_port"})->pack(-side=>'left',-fill=>"x",-expand=>0);
    if ($OS_win) {
     $top_fr4->Radiobutton(-text => 'Com 1',-value=>'COM1',-width=>9,-variable=>\$cfg{"portname"})->pack(-side=>'left',-fill=>"x",-expand=>0);
     $top_fr4->Radiobutton(-text => 'Com 2',-value=>'COM2',-width=>9,-variable=>\$cfg{"portname"})->pack(-side=>'left',-fill=>"x",-expand=>0);
     $top_fr4->Radiobutton(-text => 'Com 3',-value=>'COM3',-width=>9,-variable=>\$cfg{"portname"})->pack(-side=>'left',-fill=>"x",-expand=>0);
    } else {
     $top_fr4->Radiobutton(-text => '/dev/ttyS0',-value=>'/dev/ttyS0',-width=>9,-variable=>\$cfg{"portname"})->pack(-side=>'left',-fill=>"x",-expand=>0);
     $top_fr4->Radiobutton(-text => '/dev/ttyS1',-value=>'/dev/ttyS1',-width=>9,-variable=>\$cfg{"portname"})->pack(-side=>'left',-fill=>"x",-expand=>0);    
     $top_fr4->Radiobutton(-text => '/dev/ttyS2',-value=>'/dev/ttyS2',-width=>9,-variable=>\$cfg{"portname"})->pack(-side=>'left',-fill=>"x",-expand=>0);    
    }     

    my $mid_frame	=$smain->Frame(-relief=>'groove',-borderwidth=>2)->pack(-side=>'top',-fill=>'both',-expand=>1,-ipady=>1);
    my $mid_frameb	=$mid_frame->Frame(-label=>"ADC1001/ADC0803",-relief=>'groove',-borderwidth=>0,-height=>$lab_height)->pack(-side=>'top',-fill=>'both',-expand=>0,-ipady=>3);    

    my $mid_fr0		=$mid_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>0,-ipady=>0);
    my $mid_fr0l	=$mid_fr0->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid_fr0m	=$mid_fr0->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid_fr0r	=$mid_fr0->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'right',-fill=>'x',-expand=>1,-ipady=>0);
    # $mid_fr0l->Label(-text=>"Adr.:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    # $mid_fr0l->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"PCF8591_ADR"})->pack(-side=>'left');    
    $mid_fr0l->Label(-text=>"Res.:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid_fr0l->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"ADC_DIG"})->pack(-side=>'left');    
    # $mid_fr0m->Label(-text=>"OP-Amp:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    # $mid_fr0m->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"ADC_OPAMP"})->pack(-side=>'left'); 
    $mid_fr0m->Label(-text=>"Interval:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid_fr0m->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"interval"})->pack(-side=>'left');       
    $mid_fr0m->Label(-text=>"Ref UB:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid_fr0m->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"ADC_REFUB"})->pack(-side=>'left');    

    my $mid_fr1		=$mid_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>0,-ipady=>0);
    my $mid_fr1l	=$mid_fr1->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid_fr1m	=$mid_fr1->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid_fr1r	=$mid_fr1->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'right',-fill=>'x',-expand=>1,-ipady=>0);
    #$mid_fr1l->Label(-text=>"Res.:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #$mid_fr1l->Entry(-background=>'white',-width=>9,-state=>'disabled',-textvariable=>\$cfg{"PCF_DIG"})->pack(-side=>'left');    
    #$mid_fr1m->Label(-text=>"Channel:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #$mid_fr1m->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"PCF_CHANNEL"})->pack(-side=>'left');    
    # $mid_fr1l->Label(-text=>"Interval:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    # $mid_fr1l->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"interval"})->pack(-side=>'left');    
    #$mid_fr1m->Label(-text=>"Offset:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #$mid_fr1m->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"offset"})->pack(-side=>'left');    
    #$mid_fr1r->Label(-text=>"Multi:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #$mid_fr1r->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"MULTI"})->pack(-side=>'left');    

    my $mid_fr2		=$mid_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>0,-ipady=>0);
    my $mid_fr2l	=$mid_fr2->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid_fr2m	=$mid_fr2->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid_fr2r	=$mid_fr2->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'right',-fill=>'x',-expand=>1,-ipady=>0);
    #$mid_fr2l->Label(-text=>"Corr:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #$mid_fr2l->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"MG_KL"})->pack(-side=>'left');    
    #$mid_fr2m->Label(-text=>"min.Cor:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #$mid_fr2m->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"MG_MIN"})->pack(-side=>'left');    
    #$mid_fr2r->Label(-text=>"min.Cor:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #$mid_fr2r->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"MG_MAX"})->pack(-side=>'left'); 
    my $mid_fr3		=$mid_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>0,-ipady=>0);
    my $mid_fr3l	=$mid_fr3->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid_fr3m	=$mid_fr3->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid_fr3r	=$mid_fr3->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'right',-fill=>'x',-expand=>1,-ipady=>0);
    $mid_fr3l->Label(-text=>"Func:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid_fr3l->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"FUNC"})->pack(-side=>'left');    
    $mid_fr3l->Label(-text=>"  (0=ADC,1=Vrms,2=mW,3=dBm)",-width=>28,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    
    my $mid1_frame	=$smain->Frame(-relief=>'groove',-borderwidth=>2)->pack(-side=>'top',-fill=>'both',-expand=>1,-ipady=>1);
    my $mid1_frameb	=$mid1_frame->Frame(-label=>"Scale",-relief=>'groove',-borderwidth=>0,-height=>$lab_height)->pack(-side=>'top',-fill=>'both',-expand=>0,-ipady=>3);    

    my $mid1_fr0	=$mid1_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>0,-ipady=>0);
    my $mid1_fr0l	=$mid1_fr0->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid1_fr0m	=$mid1_fr0->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid1_fr0r	=$mid1_fr0->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'right',-fill=>'x',-expand=>1,-ipady=>0);
    $mid1_fr0l->Label(-text=>"Label:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    # $mid1_fr0l->Entry(-background=>'white',-width=>9,-textvariable=>\$llab)->pack(-side=>'left');    
    $mid1_fr0l->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"Label"})->pack(-side=>'left');    
    $mid1_fr0m->Label(-text=>"Title:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid1_fr0m->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"TITLE"})->pack(-side=>'left');    
    $mid1_fr0r->Label(-text=>"Info:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid1_fr0r->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"opttext"})->pack(-side=>'left');    

    my $mid1_fr1	=$mid1_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>0,-ipady=>0);
    my $mid1_fr1l	=$mid1_fr1->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid1_fr1m	=$mid1_fr1->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid1_fr1r	=$mid1_fr1->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'right',-fill=>'x',-expand=>1,-ipady=>0);
    $mid1_fr1l->Label(-text=>"Angle:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid1_fr1l->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"angle"})->pack(-side=>'left');    
    $mid1_fr1m->Label(-text=>"Multi:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid1_fr1m->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"MULTI"})->pack(-side=>'left');    
    #$mid1_fr1m->Label(-text=>"AngStep:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #$mid1_fr1m->Entry(-background=>'white',-width=>9,-textvariable=>\$angle_step)->pack(-side=>'left');    
    $mid1_fr1r->Label(-text=>"ScWidth:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid1_fr1r->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"scale_width"})->pack(-side=>'left');    

    my $mid1_fr2	=$mid1_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>0,-ipady=>0);
    my $mid1_fr2l	=$mid1_fr2->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid1_fr2m	=$mid1_fr2->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid1_fr2r	=$mid1_fr2->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'right',-fill=>'x',-expand=>1,-ipady=>0);
    $mid1_fr2l->Label(-text=>"Start:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid1_fr2l->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"start_val"})->pack(-side=>'left');    
    $mid1_fr2m->Label(-text=>"End:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid1_fr2m->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"end_val"})->pack(-side=>'left');    
    $mid1_fr2r->Label(-text=>"Display:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid1_fr2r->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"display"})->pack(-side=>'left');    

    my $mid1_fr3	=$mid1_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>0,-ipady=>0);
    my $mid1_fr3l	=$mid1_fr3->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid1_fr3m	=$mid1_fr3->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid1_fr3r	=$mid1_fr3->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'right',-fill=>'x',-expand=>1,-ipady=>0);
    $mid1_fr3l->Label(-text=>"StepB:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid1_fr3l->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"step_val_b"})->pack(-side=>'left');    
    $mid1_fr3m->Label(-text=>"StepS:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid1_fr3m->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"step_val_s"})->pack(-side=>'left');    
    $mid1_fr3r->Label(-text=>"LabDiv:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid1_fr3r->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"label_div"})->pack(-side=>'left');    

    my $mid2_frame	=$smain->Frame(-relief=>'groove',-borderwidth=>2)->pack(-side=>'top',-fill=>'both',-expand=>1,-ipady=>1);
    my $mid2_frameb	=$mid2_frame->Frame(-label=>"Colors",-relief=>'groove',-borderwidth=>0,-height=>$lab_height)->pack(-side=>'top',-fill=>'both',-expand=>0,-ipady=>3);    

    my $mid2_fr0	=$mid2_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>0,-ipady=>0);
    my $mid2_fr0l	=$mid2_fr0->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid2_fr0m	=$mid2_fr0->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid2_fr0r	=$mid2_fr0->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'right',-fill=>'x',-expand=>1,-ipady=>0);
    $mid2_fr0l->Label(-text=>"Label:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid2_fr0l->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"c_a_Label"})->pack(-side=>'left');    
    $mid2_fr0m->Label(-text=>"Scale:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid2_fr0m->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"c_a_Scale"})->pack(-side=>'left');    
    $mid2_fr0r->Label(-text=>"BackG:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid2_fr0r->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"c_a_background"})->pack(-side=>'left');    

    my $mid2_fr1	=$mid2_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>0,-ipady=>0);
    my $mid2_fr1l	=$mid2_fr1->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid2_fr1m	=$mid2_fr1->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid2_fr1r	=$mid2_fr1->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'right',-fill=>'x',-expand=>1,-ipady=>0);
    $mid2_fr1l->Label(-text=>"Display:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid2_fr1l->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"c_a_disp"})->pack(-side=>'left');    
    $mid2_fr1m->Label(-text=>"Info:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid2_fr1m->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"c_a_info"})->pack(-side=>'left');    
    $mid2_fr1r->Label(-text=>"Frame:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid2_fr1r->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"c_a_outFrame"})->pack(-side=>'left');    

    my $mid2_fr2	=$mid2_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>0,-ipady=>0);
    my $mid2_fr2l	=$mid2_fr2->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid2_fr2m	=$mid2_fr2->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    my $mid2_fr2r	=$mid2_fr2->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'right',-fill=>'x',-expand=>1,-ipady=>0);
    $mid2_fr2l->Label(-text=>"Pointer:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid2_fr2l->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"c_a_pointer"})->pack(-side=>'left');    
    $mid2_fr2m->Label(-text=>"Shade:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid2_fr2m->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"c_a_pointer_shd"})->pack(-side=>'left');    
    $mid2_fr2r->Label(-text=>"Tags:",-width=>8,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    $mid2_fr2r->Entry(-background=>'white',-width=>9,-textvariable=>\$cfg{"c_a_tags"})->pack(-side=>'left');    

#########

    #my $bot_frame	=$smain->Frame(-relief=>'groove',-borderwidth=>2)->pack(-side=>'bottom',-fill=>'both',-expand=>1,-ipady=>1);
    #my $bot_frameb	=$bot_frame->Frame(-label=>"SWR-Mode",-relief=>'groove',-borderwidth=>0,-height=>$lab_height)->pack(-side=>'top',-fill=>'both',-expand=>0,-ipady=>0);    

    #my $bot_fr0		=$bot_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>0,-ipady=>0);
    #my $bot_fr0l	=$bot_fr0->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-fill=>'x',-expand=>1,-ipady=>0);
    #my $bot_fr0r	=$bot_fr0->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'right',-fill=>'x',-expand=>1,-ipady=>0);
    #$bot_fr0l->Label(-text=>"Ch-FWD:",-width=>15,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #$bot_fr0l->Entry(-background=>'white',-width=>12,-textvariable=>\$cfg{"SWR_CHAN1"})->pack(-side=>'left');    
    #$bot_fr0r->Label(-text=>"Ch-Ref:",-width=>12,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #$bot_fr0r->Entry(-background=>'white',-width=>12,-textvariable=>\$cfg{"SWR_CHAN2"})->pack(-side=>'left');    

    #my $bot_fr1		=$bot_frameb->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'top',-fill=>'x',-expand=>1,-ipady=>0);
    #$bot_fr1->Label(-text=>"SWR-Mode:",-width=>15,-anchor=>'w')->pack(-side=>"left",-anchor=>'w',-fill=>'x',-expand=>0);
    #$bot_fr1->Radiobutton(-text => 'On',-value=>1,-width=>6,-variable=>\$cfg{"SWR_MODE"})->pack(-side=>'left',-fill=>"x",-expand=>0);
    #$bot_fr1->Radiobutton(-text => 'Off',-value=>0,-width=>6,-variable=>\$cfg{"SWR_MODE"})->pack(-side=>'left',-fill=>"x",-expand=>0);
        
    # Strg-Q Ende ohne speichern , Stg-O Config speichern
    $smain->bind('<Control-q>', sub {$smain->destroy();});   
    $smain->bind('<Control-o>', sub {adc_utils::write_config($config,%cfg,);my_ok();}); 
    
     #  Doppelklick auf Listen Eintrag zum auswhlen  einer Config
     $smain->bind('Tk::Listbox','<Double-Button-1>'=> sub { cfg_select() });
     
   # MainLoop; 
 }
 
   
###########################
# Subs
###########################

sub my_ok() {
 $def_config = $config;
 adc_utils::logmsg("Setup write_config... $def_config");
 adc_utils::write_config($def_config,%cfg);
 adc_utils::logmsg("Setup get_config... $def_config");
 %cfg=&adc_utils::get_config($def_config,\%cfg);
 $smain->destroy(); 
 $range_start		= $cfg{"start_val"};	# Start / Endbereich sichern
 $range_end		= $cfg{"end_val"};
 call_createDisplay();
 $debug 		= $cfg{"Debug"};
}


sub my_cancel() {
 # $def_config = $config;
 adc_utils::logmsg("Setup cancel...");
 # %cfg=&adc_utils::get_config($def_config,\%cfg);
 $smain->destroy(); 
 $range_start		= $cfg{"start_val"};	# Start / Endbereich sichern
 $range_end		= $cfg{"end_val"};
 call_createDisplay();
}


sub fill_lb($) {
 my $config = shift;
 my $n = 0;
 my @a;
 opendir(DIR, $dir); # || ksm::exit(31010,"Directory $CURR_DIR kann nicht geffnet werden.");
 @a = grep(/\.cfg$/ , readdir(DIR));
 @cfg_files = sort(@a);
 closedir(DIR);
 foreach (sort @cfg_files) {
  $lb->insert($n,basename($_));
  if( basename($config) eq basename($_) ) {
   $cfg_active = $n;
  }
  $n++;
 }
}

sub cfg_select() {
 my $temp_file		= "log/adc_temp";	# Temp File
 adc_utils::write_config($config,%cfg,);	# Aktuelle Konfig Schreiben
 $cfg_active=$lb->curselection;			# Neu gew. Config holen
 $config = $dir."/".$cfg_files[$cfg_active];
 %cfg=&adc_utils::get_config($config,\%cfg);
 # $smain->destroy(); 
 # call_createDisplay;
 my_ok();
}

#---------------------------------------------------------------------------------
#------------------------------        Ende      ---------------------------------
#---------------------------------------------------------------------------------

__END__
=head1 NAME

adc_analog.pl - Ver. 0.1 / 29.03.2003

=head1 SYNOPSIS

	Analoge Anzeige der vom HF-mV Meter gelieferten Daten. 
	Je nach Konfiguration sind sind derzeit folgende Funktionen moeglich:
	0 = ADC 	, direkte Anzeige des AD-Wertes, 
	1 = VRms 	, Anzeige der berechneten Spannung 
	2 = mW		, Anzeige der Leistung 
	3 = dBm		, Anzeige in dBm

=head1 DESCRIPTION 

	Der Aufruf erfolgt mit Angabe einer Konfigurationsdatei
	
	z.B. adc_analog.pl -c cfg_lin/dbm.cfg 
	
	Verschiedene Beispielskonfigurationen sind 
	unter cfg_win (Windows) bzw. cfg_lin (Unix/Linux) zu finden.
	
	Neue Konfigs koennen mit dem Parameter -w erzeugt werden
	adc_analog.pl -c cfg_lin/neue.cfg -w
	und mit Ctrl-A bearbeitet werden.
	
	Das Programm kann mit Ctrl-Q beendet werden.
	
	Beschreibung der Konfigurationsvariablen:
	
	AD-Wandler
	Res 		Zahl	Aufloesung AD-Wandler, ADC1001 = 10 Bit = 1023 , ADC0803 = 8 Bit = 255
	Intervall	Zahl	Messintervall in mS
	RefUB		Zahl	Referenzspannung (5.00 V)
	Func		Zahl	[0..3],
						0 = ADC , direkte Anzeige des AD-Wertes, 
						1 = VRms, Anzeige der berechneten Spannung 
						2 = mW	, Anzeige der Leistung 
						3 = dBm	, Anzeige in dBm

	Skala
	Label		Text	Anzeige im Display	
	Title		Text	Fenstertitel wird erst nach Neustartangzeigt
	Info		Text	Anzeige Info rechte untere Ecke im Display
	Angle		Zahl	Auszufuellender Winkel der Skala
	Multi		Zahl	Multiplikator des berechneten Wertes
	ScWidth 	Zahl	Breite der Skala
	Start		Zahl	Anfangswert der Skala
	End 		Zahl	Endwert der Skala
	Display 	Zahl	[0..2] , 
						0 nur Anzeige Abschwaecher	
						1 Anzeige Abschwaecher und Berechneter Wert in Abhaengigkeit der 	gew. Funktion
						2 Erweiterte Anzeige aller Werte unterhalb der Skala
	StepB		Zahl	Intervall der Werte Beschriftungen der Skala
	StepS		Zahl	Hilfsintervall	
	LabDiv		Zahl	Teiler Skalenbeschriftung 
	
	Farben	, Farbnamen koennen als Name z.B. black oder auch als RGB z.B. #ff00ff angegeben werden
	Label		Text	Farbe des Labels 
	Scale		Text	Farbe der Skala
	BackG		Text	Display Hintergrundfarbe
	Display 	Text	Farbe Displaytext
	Info		Text	Farbe Info-text
	Frame		Text	Farbe des umgebenden Rahmens 
	Pointer 	Text	Farbe des Zeigers
	Shade		Text	Farbe des Schattens 
	Tags		Text	Farbe der Teilstriche der Skala
	
=head1 AUTHOR
IngoGerlach@welfen-netz.com (DH1AAD) 29.03.2003
 
=head1 SEE ALSO
 
perl(1).
 
=cut

